//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3EA06DB403D9.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3EA06DB403D9.cm

//## begin module%3EA06DB403D9.cp preserve=no
//## end module%3EA06DB403D9.cp

//## Module: Step%3EA06DB403D9; Package body
//## Subsystem: XSFit::Fit%3677C9158350
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSFit/Fit/Step.cxx

//## begin module%3EA06DB403D9.additionalIncludes preserve=no
//## end module%3EA06DB403D9.additionalIncludes

//## begin module%3EA06DB403D9.includes preserve=yes
//## end module%3EA06DB403D9.includes

// Fit
#include <XSFit/Fit/Fit.h>
// Step
#include <XSFit/Fit/Step.h>


//## begin module%3EA06DB403D9.declarations preserve=no
//## end module%3EA06DB403D9.declarations

//## begin module%3EA06DB403D9.additionalDeclarations preserve=yes
#include <XSFit/Fit/StatMethod.h>
#include <XSModel/GlobalContainer/ModelContainer.h>
#include <XSModel/GlobalContainer/ResponseContainer.h>
#include <XSModel/Parameter/ResponseParam.h>
#include <XSUtil/Utils/XSstream.h>
#include <XSUtil/Parse/XSparse.h>
#include <XSContainer.h>
#include <XSsymbol.h>
#include <XSstreams.h>  
#include <iomanip>
#include <limits>
#include <sstream>
//## end module%3EA06DB403D9.additionalDeclarations


// Class Step 

Step::Step (Fit* fit)
  //## begin Step::Step%41F91AC2012E.hasinit preserve=yes
  : m_best(false),
    m_bestFit(.0),
    m_fit(fit),
    m_increasing(),
    m_minStatFound(std::numeric_limits<double>::max()),
    m_minStatParams()
  //## end Step::Step%41F91AC2012E.hasinit
  //## begin Step::Step%41F91AC2012E.initialization preserve=yes
  //## end Step::Step%41F91AC2012E.initialization
{
  //## begin Step::Step%41F91AC2012E.body preserve=yes
  //## end Step::Step%41F91AC2012E.body
}


Step::~Step()
{
  //## begin Step::~Step%3EA06B7502E9_dest.body preserve=yes
  //## end Step::~Step%3EA06B7502E9_dest.body
}



//## Other Operations (implementation)
void Step::doGrid ()
{
  //## begin Step::doGrid%3EA9A90700D1.body preserve=yes
  using namespace std;      
  
  // suppress all fit messages - this isn't quite what we want
   
  SpecContainer& parameters = parameter();
  int N(parameters.size());
  m_increasing.clear();
  m_increasing.resize(N, true);
  const bool saveFitStatus = m_fit->isStillValid();
  m_minStatFound = numeric_limits<double>::max();
  m_minStatParams.clear();
  SpecContainer::iterator p    = parameters.begin();
  SpecContainer::iterator pEnd = parameters.end();
  try
  {
     while ( p != pEnd )
     {
        ParameterSpec*& spec = *p; 

        // freeze each parameter by removing from list of fit's variable
        // parameters. They will be added on command exit. 
        m_fit->freezeByIndex(spec->fullFitIndex);
        ModParam* mp = spec->address;
        // Freeze call really only matters for norm param, since that will
        // be accessed even if it's not part of fit->variableParameters map
        // (see StatMethod::renorm function).  
        mp->freeze();
        mp->setValue(spec->lowRange,'v');
        ++p;
     } 
     m_fit->calculateModel();   
     std::vector<Real>& highestDimensionArray = parameters.back()->parameterValues;
     int Npt ( highestDimensionArray.size());
     IntegerArray coords(N,0);

     bool TITLE(true);

     report(TITLE);

     if ( N > 1 )
     {
        for ( int pt = 0; pt < Npt; ++pt)
        {
           parameters[N-1]->value = highestDimensionArray[pt];
           coords[N-1] = pt;
           stepThruDimension(N-1,pt,coords);
        }
     }
     else
     {
        for ( int pt = 0; pt < Npt; ++pt)
        {
           parameters[0]->value = highestDimensionArray[pt];
           doPoint();
           Real stat(m_fit->statistic());
           if (stat < m_minStatFound)
           {
              m_minStatFound = stat;
              m_minStatParams[parameters[0]->fullFitIndex] = parameters[0]->value;
              std::map<int,ModParam*>::const_iterator itVar = m_fit->variableParameters().begin();       
              std::map<int,ModParam*>::const_iterator itEnd = m_fit->variableParameters().end();
              while (itVar != itEnd)
              {
                 m_minStatParams[itVar->first] = itVar->second->value('v');
                 ++itVar;
              }
           }

	   ios_base::fmtflags saveFmt(tpout.flags());
           size_t savePrecision(tpout.precision());
	   tpout.setf(ios_base::showpoint|ios_base::right,ios_base::scientific);
	   tpout.precision(5);		

	   tpout << right << setw(16) << stat
		 << right << setw(12) << stat - m_bestFit;

	   tpout << right << setw(5) << pt
		 << right << setw(12) << parameters[0]->parameterValues[pt] << std::endl;

           tpout.flags(saveFmt);
           tpout.precision(savePrecision);
           grid()[pt] = stat;
        }

     }
     restoreFit();
     m_fit->isStillValid(saveFitStatus);
  }
  catch (...)
  {
     restoreFit();
     m_fit->isStillValid(saveFitStatus);
     throw;
  }
     
  //## end Step::doGrid%3EA9A90700D1.body
}

void Step::retrieveParameter (const Fit* fit, const string& paramIDStr, ModParam*& parameter, int& paramIndex, int& fullIndex, string& paramName)
{
  //## begin Step::retrieveParameter%3EAE923D0298.body preserve=yes
  using namespace XSContainer;
    
  if (paramIDStr.empty())
  {
     throw InvalidParameter("Empty parameter identifier");
  }  
    
  // Must check for response param.  These will be indicated by "r<par idx>"
  // or "<source idx>:r<par idx>".  Look for the 'r'.
  string::size_type rPos = string::npos;
  const string::size_type colonPos = paramIDStr.find(':');
  if (colonPos == string::npos)
  {
     if (paramIDStr[0] == 'r' || paramIDStr[0] == 'R')
        rPos = 0;
  }
  else
  {
     if (paramIDStr.length() > (colonPos+1) && 
         (paramIDStr[colonPos+1] == 'r' || paramIDStr[colonPos+1] == 'R'))
        rPos = colonPos+1;
  }
  const bool isRespPar = (rPos != string::npos);
  
  const Parameter* par=0; 
  string modelName;
  if (isRespPar)
  {
     int parIdx=0;
     int sourceIdx=0;
     // must remove the 'r'
     string correctedIDStr(paramIDStr);
     correctedIDStr.erase(rPos,1);
     if (XSparse::integerPair(correctedIDStr, sourceIdx, parIdx))
     {
        if (parIdx == -1)
        {
           parIdx = sourceIdx;
           sourceIdx = 1;
        }
        const RespParContainer& respPars = responses->respParContainer();
        if (static_cast<int>(respPars.size()) >= sourceIdx)
           if (parIdx > 0 && static_cast<int>(respPars[sourceIdx-1].size()) >= parIdx)
           {
              par = respPars[sourceIdx-1][parIdx-1];
              // full index is given by respFloor = (2^15 - 1)*2^16 = 2^31 - 2^16
              // + 1-based position in the respPars container
              // (see Fit::initializeFitParameters).
              size_t pos=1;
              for (int i=0; i<(sourceIdx-1); ++i)
                 pos += respPars[i].size();
              pos += parIdx-1;
              fullIndex = (Fit::RESPAR_INDEX() << ModelContainer::SHIFT()) + 
                                static_cast<int>(pos);   
              paramIndex = parIdx;
           }
        if (sourceIdx > 1)
        {
           std::ostringstream oss;
           oss << sourceIdx;
           // "modelName" in this context is simply the source number
           modelName = oss.str();
        }
     } 
  } // end if respPar
  else
  {
     size_t index=0;  
     XSparse::stringIntPair(paramIDStr,modelName,index);
     paramIndex = static_cast<int>(index);
     fullIndex = models->fullIndex(index,modelName);
     par = models->lookupParameter(fullIndex);
  }
  
  if (par)
  {
     if ( modelName.length())
     {
         paramName = modelName + string(":");       
     }
     paramName += par->name();
     parameter = fit->variableParameters(fullIndex);
     if ( !parameter )
     {
         string msg (" Step: Parameter ");
         msg += paramIDStr;
         msg += " is not variable";
         throw InvalidParameter(msg);                       
     }               
  }
  else
  {
     string msg (" Step: Parameter ");
     msg += paramIDStr;
     msg += " is not defined.";
     msg += "\n   If parameter belongs to a named model, must enter <model name>:<par idx>.";
     msg += "\n   If trying to access a response parameter, use 'r' specifier: [<sourc num>:]r<par idx>.";
     throw InvalidParameter(msg);        
  }
   
     
  //## end Step::retrieveParameter%3EAE923D0298.body
}

void Step::stepThruDimension (int dimension, int point, IntegerArray& coordinates)
{
  //## begin Step::stepThruDimension%3EB27C43025F.body preserve=yes
    SpecContainer& parameters = parameter();
    const size_t N (parameters.size());
    int nextDimension (dimension - 1);
    std::vector<Real>& currentParamArray = parameters[dimension - 1]->parameterValues; 
    const size_t NCD ( currentParamArray.size() );        
        
    using namespace std;

    if ( dimension != 1)
    {
	// iterate forwards
	if  ( m_increasing[dimension - 1])
	{
	    for ( size_t j = 0; j < NCD; ++j )
	    {
		parameters[dimension-1]->value = currentParamArray[j];
		coordinates[dimension-1] = j;
		stepThruDimension(nextDimension,j,coordinates);
	    }
	    m_increasing[dimension-1] = false;
	}
	else
	{
	    for ( int j = NCD - 1; j >= 0; --j)
	    {
		parameters[dimension-1]->value = currentParamArray[j];
		coordinates[dimension-1] = j;
		stepThruDimension(nextDimension,j,coordinates);
	    }
	    m_increasing[dimension-1] = true;
	}
    }      
    else
    {
	int j = 0, limit = NCD - 1, incr = 1;

	if  ( !m_increasing[0] )
	{
	    j = NCD - 1;
	    incr = -1;
	    limit = 0;
	}

	ios_base::fmtflags saveFmt(tpout.flags());
        size_t savePrecision(tpout.precision());
	tpout.setf(ios_base::showpoint|ios_base::right,ios_base::scientific);
	tpout.precision(5);

	for(; (incr > 0 ? j <= limit : j >= limit); j += incr)
	{
	    parameters[0]->value = currentParamArray[j];
	    coordinates[0] = j;
	    // here and below we should have a correct set of
	    // parameter values and be able to replace this 
	    // output with the function that actually fits.
	    doPoint();
	    //XSutility::starPrint("Calculating...",j,tcout);
	    Real stat(m_fit->statistic());
            if (stat < m_minStatFound)
            {
               m_minStatFound = stat;
               for (size_t i=0; i<N; ++i)
                  m_minStatParams[parameters[i]->fullFitIndex] = 
                        parameters[i]->value;
               std::map<int,ModParam*>::const_iterator itVar = m_fit->variableParameters().begin();       
               std::map<int,ModParam*>::const_iterator itEnd = m_fit->variableParameters().end();
               while (itVar != itEnd)
               {
                  m_minStatParams[itVar->first] = itVar->second->value('v');
                  ++itVar;
               }        
            }

	    tpout << right << setw(16) << stat
		  << right << setw(12) << stat - m_bestFit;
				
	    for(int i = 0; i < static_cast<int>(N); ++i)
		tpout << right << setw(5) << coordinates[i]
		      << right << setw(12) << parameters[i]->parameterValues[coordinates[i]];

	    tpout << endl;

	    int arrayPoint(coordinates[0]);
	    int block(1);
	    for (size_t k = 1; k < N; ++k)
	    {
		block *= (parameters[k - 1]->intervals + 1);
		arrayPoint += block*coordinates[k];       
	    }
	    grid()[arrayPoint] = stat;
	}
        tpout.flags(saveFmt);
        tpout.precision(savePrecision);
	m_increasing[0] = !m_increasing[0];
    }        
        
        
  //## end Step::stepThruDimension%3EB27C43025F.body
}

void Step::restoreFit ()
{
  //## begin Step::restoreFit%3EB2C3C80335.body preserve=yes
  SpecContainer& parameters = parameter();     
  SpecContainer::iterator sp = parameters.begin();
  SpecContainer::iterator spEnd = parameters.end();
  
  // put back parameters into fit's variable parameters set. 
  while ( sp != spEnd )
  {
        ParameterSpec*& p = *sp;
        p->address->thaw();  
        m_fit->variableParameters(p->fullFitIndex,p->address);         
        ++sp;       
  }
  
  std::map<int,ModParam*>::const_iterator v (m_fit->variableParameters().begin());       
  std::map<int,ModParam*>::const_iterator vEnd (m_fit->variableParameters().end());
  while ( v != vEnd )
  {
          int index ( v->first );
          Real oldVal = m_fit->oldParameterValues(index)->value('v');
          m_fit->variableParameters(index)->setValue(oldVal,'v'); 
          ++v;     
  }       
  
  // go through again and set the value fields of the parameter specs to the 
  // best fit value.
  sp = parameters.begin();
  for ( ; sp != spEnd; ++sp ) (*sp)->value = (m_fit->variableParameters((*sp)->fullFitIndex)->value('v'));
  
  m_fit->calculateModel();
  
  // We want the parameters set back to their original values prior to steppar,
  // so no renormalization.
  Fit::RenormSetting saveRenorm = m_fit->renormType();
  m_fit->renormType(Fit::NONE);
  try
  {
     m_fit->initializeStatistic();
  }
  catch (...)
  {
     m_fit->renormType(saveRenorm);
     throw;
  }
  m_fit->renormType(saveRenorm);
  //## end Step::restoreFit%3EB2C3C80335.body
}

void Step::doPoint ()
{
  //## begin Step::doPoint%3EB6BA0602EE.body preserve=yes
  SpecContainer& parameters = parameter();     
  SpecContainer::iterator sp = parameters.begin();
  SpecContainer::iterator spEnd = parameters.end();
  // the parameters held in SpecContainer have been taken out of Fit's variable
  // parameter set and are therefore frozen. Now we set those parameter values to
  // the grid array values and fit .
  while ( sp != spEnd )
  {
        ModParam* mp ( (*sp)->address );
        mp->setValue((*sp)->value ,'v' ); 
        ++sp;       
  }
  if ( m_best )
  {
        // the set of indices of variableParameters is a subset of that of
        // oldParameterValues
        std::map<int,ModParam*>::const_iterator v (m_fit->variableParameters().begin());       
        std::map<int,ModParam*>::const_iterator vEnd (m_fit->variableParameters().end());
        while ( v != vEnd )
        {
                int index ( v->first );
                Real oldVal = m_fit->oldParameterValues(index)->value('v');
                m_fit->variableParameters(index)->setValue(oldVal,'v'); 
                ++v;     
        }       
  }
  
  // 
  m_fit->calculateModel();
  
  if (m_fit->variableParameters().size())  
  {
     // renorm, DOF check, recompute current statistic
     m_fit->initializeStatistic();

     m_fit->perform();
  }
  else
  {
     m_fit->statMethod()->perform(m_fit);
  }
  //## end Step::doPoint%3EB6BA0602EE.body
}

void Step::report (bool title) const
{
  //## begin Step::report%3EDCD40201AC.body preserve=yes
    using namespace std;
    // preserve current chatter level settings and force output.
    int con (tpout.consoleChatterLevel());
    int log (tpout.logChatterLevel());
    tpout.consoleChatterLevel( tpout.conVerbose() );
    tpout.logChatterLevel( tpout.logVerbose() );

    StatMethod* stat = m_fit->statMethod();

    const SpecContainer& parameters = getParameter();
    int Npar  (parameters.size());
    if ( title )
    {
            tpout << "\n" << setw(16) <<  stat->fullName()
                  << setw(12)   <<   "  Delta   "; 
            for (int  j = 0; j < Npar; ++j )
            {
                tpout << setw(14) << parameters[j]->name;       
            }

            tpout << "\n";
            tpout << setw(16) <<    " "
                  << setw(12)   <<   stat->fullName(); 
            for (int  j = 0; j < Npar; ++j )
            {
                tpout << setw(14) << parameters[j]->address->index();       
            }
            tpout << endl << endl;

    }
    else
    {
            ios_base::fmtflags save(tpout.flags());
            tpout.setf(ios_base::showpoint|ios_base::right,ios_base::scientific);
            tpout.precision(5);
            int Ngrid (getGrid().size());
            IntegerArray coordinates(Npar,0);
            IntegerArray offsets (Npar,1);
            for (int k = 1; k < Npar; ++k) 
            {
                    offsets[k] = parameters[k]->parameterValues.size()*offsets[k-1];
            }
            // arrayPoint, iteration.

            for (int j = 0; j < Ngrid; ++j)
            { 
                    int k (Npar-1);
                    int remainder = j;
                    while ( k >=  0)
                    {

                            coordinates[k] = remainder / ( offsets[k] );
                            remainder -= coordinates[k] * offsets[k];
                            --k;                        
                    }
                    Real stat = getGrid()[j];
                    tpout << right << setw(16)  << stat  << right << setw(12)  << stat - m_bestFit; 
                    for (k = 0 ; k < Npar; ++k)
                    {
                            tpout << right << setw(4)  << coordinates[k]  
                                  << right << setw(8)  
                                  << parameters[k]->parameterValues[coordinates[k]]; 
                    }
                    tpout << '\n';
            }
            tpout.flags(save);                               

    }
    tpout << flush;


    tpout.consoleChatterLevel(con);
    tpout.logChatterLevel(log);

  //## end Step::report%3EDCD40201AC.body
}

// Additional Declarations
  //## begin Step%3EA06B7502E9.declarations preserve=yes
  //## end Step%3EA06B7502E9.declarations

//## begin module%3EA06DB403D9.epilog preserve=yes
//## end module%3EA06DB403D9.epilog
